function estimated_positions = connect_to_closest(track_1x,track_1y,track_2x,track_2y,prevobj1_x,prevobj1_y,prevobj2_x,prevobj2_y )

%{
track_1x    = track_1(1);
track_1y    = track_1(2);
track_2x    = track_2(1);
track_2y    = track_2(2);
prevobj1_x  = prev_track1_x(sim_length-1);
prevobj1_y  = prev_track1_y(sim_length-1);
prevobj2_x  = prev_track2_x(sim_length-1);
prevobj2_y  = prev_track2_y(sim_length-1);
%}

estimated_positions = zeros(1,4);

% Combine the two tracks which gives the smallest sum
% Possiblity 1: track_1 = object_1, track_2 = object_2
a = sqrt( (prevobj1_x - track_1x).^2 + (prevobj1_y - track_1y).^2);
b = sqrt( (prevobj2_x - track_2x).^2 + (prevobj2_y - track_2y).^2);
% Possiblity 2: track_1 = object_2, track_2 = object_1
c = sqrt( (prevobj1_x - track_2x).^2 + (prevobj1_y - track_2y).^2);
d = sqrt( (prevobj2_x - track_1x).^2 + (prevobj2_y - track_1y).^2);


if track_2x == 0 && a < d && a < 2
    estimated_positions(1) = track_1x;
    estimated_positions(2) = track_1y;
elseif track_2x == 0 && d < a && d < 2
    estimated_positions(3) = track_1x;
    estimated_positions(4) = track_1y;
elseif a+b < c+d && a+b < 4
    estimated_positions(1) = track_1x;
    estimated_positions(2) = track_1y;
    estimated_positions(3) = track_2x;
    estimated_positions(4) = track_2y;
else
    estimated_positions(3) = track_1x;
    estimated_positions(4) = track_1y;
    estimated_positions(1) = track_2x;
    estimated_positions(2) = track_2y;
end

end