function estimated_close_positions = find_2_close(track_img, max_nx, max_ny, max_nx2, max_ny2)

matrix_size = size(track_img);
estimated_close_positions = zeros(1,4);
%max_nx2 = 14; max_ny2 = 14; max_nx = 15; max_ny = 17;
mutual_node_reduce_factor = 0.5;

%% Coarse positioning
% Create missing nodes if attempting to access nodes outside of grid
% For one of the corner nodes:
if      max_nx == 1 & max_ny == 1 
    PAN(2:3,2:3) = track_img(max_ny:max_ny+1,max_nx:max_nx+1);
elseif  max_nx == matrix_size(2) & max_ny == 1 
    PAN(2:3,1:2) = track_img(max_ny:max_ny+1,max_nx-1:max_nx);
elseif  max_nx == 1 & max_ny == matrix_size(1) 
    PAN(1:2,2:3) = track_img(max_ny-1:max_ny,max_nx:max_nx+1);
elseif  max_nx == matrix_size(2) & max_ny == matrix_size(1) 
    PAN(1:2,1:2) = track_img(max_ny-1:max_ny,max_nx-1:max_nx);

% Along outer frame/border of display:
elseif max_nx == 1
    PAN(1:3,2:3) = track_img(max_ny-1:max_ny+1,max_nx:max_nx+1);
elseif max_ny == 1
    PAN(2:3,1:3) = track_img(max_ny:max_ny+1,max_nx-1:max_nx+1);
elseif max_nx == matrix_size(2)
    PAN(1:3,1:2) = track_img(max_ny-1:max_ny+1,max_nx-1:max_nx);
elseif max_ny == matrix_size(1)
    PAN(1:2,1:3) = track_img(max_ny-1:max_ny,max_nx-1:max_nx+1);
else
    PAN = track_img(max_ny-1:max_ny+1,max_nx-1:max_nx+1);
end

% Create missing nodes if attempting to access nodes outside of grid
% For one of the corner nodes:
if      max_nx2 == 1 & max_ny2 == 1 
    SAN(2:3,2:3) = track_img(max_ny2:max_ny2+1,max_nx2:max_nx2+1);
elseif  max_nx2 == matrix_size(2) & max_ny == 1 
    SAN(2:3,1:2) = track_img(max_ny2:max_ny2+1,max_nx2-1:max_nx2);
elseif  max_nx2 == 1 & max_ny2 == matrix_size(1) 
    SAN(1:2,2:3) = track_img(max_ny2-1:max_ny2,max_nx2:max_nx2+1);
elseif  max_nx2 == matrix_size(2) & max_ny2 == matrix_size(1) 
    SAN(1:2,1:2) = track_img(max_ny2-1:max_ny2,max_nx2-1:max_nx2);

% Along outer frame/border of display:
elseif max_nx2 == 1
    SAN(1:3,2:3) = track_img(max_ny2-1:max_ny2+1,max_nx2:max_nx2+1);
elseif max_ny2 == 1
    SAN(2:3,1:3) = track_img(max_ny2:max_ny2+1,max_nx2-1:max_nx2+1);
elseif max_nx2 == matrix_size(2)
    SAN(1:3,1:2) = track_img(max_ny2-1:max_ny2+1,max_nx2-1:max_nx2);
elseif max_ny2 == matrix_size(1)
    SAN(1:2,1:3) = track_img(max_ny2-1:max_ny2,max_nx2-1:max_nx2+1);
else
    SAN = track_img(max_ny2-1:max_ny2+1,max_nx2-1:max_nx2+1);
end

%% Halve the mutual nodes between PAN and SAN
temp_PAN = PAN;%max_nx, max_ny
temp_SAN = SAN;%max_nx2, max_ny2

% Check if "too close"
if (max_nx - max_nx2) == -1 && (max_ny - max_ny2) == 0 % PAN to the left
    PAN(1:3,3) = mutual_node_reduce_factor*PAN(1:3,3);
    SAN(1:3,1) = mutual_node_reduce_factor*SAN(1:3,1);
elseif (max_nx - max_nx2) == 1 && (max_ny - max_ny2) == 0 % PAN to the right
    PAN(1:3,1) = mutual_node_reduce_factor*PAN(1:3,1);
    SAN(1:3,3) = mutual_node_reduce_factor*SAN(1:3,3);
elseif (max_nx - max_nx2) == 0 && (max_ny - max_ny2) == -1 % PAN below
    PAN(3,1:3) = mutual_node_reduce_factor*PAN(3,1:3);
    SAN(1,1:3) = mutual_node_reduce_factor*SAN(1,1:3);
elseif (max_nx - max_nx2) == 0 && (max_ny - max_ny2) == 1 % PAN above
    PAN(1,1:3) = mutual_node_reduce_factor*PAN(1,1:3);
    SAN(3,1:3) = mutual_node_reduce_factor*SAN(3,1:3);
else
    for a = [1 2 3 4 6 7 8 9]
        for b = 1:3
            for c = 1:3
                if temp_PAN(a) == temp_SAN(b,c)
                    PAN(a) = mutual_node_reduce_factor * PAN(a);
                end
            end
        end
    end

    for a = [1 2 3 4 6 7 8 9]
        for b = 1:3
            for c = 1:3
                if temp_SAN(a) == temp_PAN(b,c)
                    SAN(a) = mutual_node_reduce_factor * SAN(a);
                end
            end
        end
    end
end

%% Fine positioning
% Center of mass estimation of PAN
%{
cluster_size = size(PAN());
cluster_sum = sum(sum(PAN()));
for jj = 1:2
    shp = [1,1];
    shp(jj) = cluster_size(jj);
    rep = cluster_size;
    rep(jj) = 1;
    ind1 = repmat(reshape(1:cluster_size(jj),shp),rep);
    com_track_img(jj) = sum(ind1(:).*PAN(:))./cluster_sum;
end

% Estimated center
estimated_close_positions(1) = com_track_img(2)+max_nx-2;
estimated_close_positions(2) = com_track_img(1)+max_ny-2;

cof_com = [com_track_img(1)+max_ny-2, com_track_img(2)+max_nx-2];
%}
%% PAN
a = (PAN(2,1)+PAN(1,1)-2*PAN(1,2)+PAN(1,3)-2*PAN(3,2)-2*PAN(2,2)+PAN(2,3)+PAN(3,1)+PAN(3,3));
b = (PAN(3,3)+PAN(1,1)-PAN(1,3)-PAN(3,1));
c = (-PAN(1,1)+PAN(1,3)-PAN(2,1)+PAN(2,3)-PAN(3,1)+PAN(3,3));
d = (-2*PAN(2,1)+PAN(1,1)+PAN(1,2)+PAN(1,3)+PAN(3,2)-2*PAN(2,2)-2*PAN(2,3)+PAN(3,1)+PAN(3,3));
e = (-PAN(1,1)-PAN(1,2)-PAN(1,3)+PAN(3,1)+PAN(3,2)+PAN(3,3));

% Relative shift of peak node
y_shift = (b*c-2*a*e)/(4*d*a-b^2);
x_shift = (b*e-2*d*c)/(4*d*a-b^2);

if x_shift > .6
    x_shift = .6;
end
if y_shift > .6
    y_shift = .6;
end
if x_shift < -.6
    x_shift = -.6;
end
if y_shift < -.6
    y_shift = -.6;
end

estimated_close_positions(1) = x_shift+max_nx;
estimated_close_positions(2) = y_shift+max_ny;

%% SAN
a = (SAN(2,1)+SAN(1,1)-2*SAN(1,2)+SAN(1,3)-2*SAN(3,2)-2*SAN(2,2)+SAN(2,3)+SAN(3,1)+SAN(3,3));
b = (SAN(3,3)+SAN(1,1)-SAN(1,3)-SAN(3,1));
c = (-SAN(1,1)+SAN(1,3)-SAN(2,1)+SAN(2,3)-SAN(3,1)+SAN(3,3));
d = (-2*SAN(2,1)+SAN(1,1)+SAN(1,2)+SAN(1,3)+SAN(3,2)-2*SAN(2,2)-2*SAN(2,3)+SAN(3,1)+SAN(3,3));
e = (-SAN(1,1)-SAN(1,2)-SAN(1,3)+SAN(3,1)+SAN(3,2)+SAN(3,3));

% Relative shift of peak node
y_shift2 = (b*c-2*a*e)/(4*d*a-b^2);
x_shift2 = (b*e-2*d*c)/(4*d*a-b^2);

if x_shift2 > .6
    x_shift2 = .6;
end
if y_shift2 > .6
    y_shift2 = .6;
end
if x_shift2 < -.6
    x_shift2 = -.6;
end
if y_shift2 < -.6
    y_shift2 = -.6;
end

estimated_close_positions(3) = x_shift2+max_nx2;
estimated_close_positions(4) = y_shift2+max_ny2;

end