function display = show_tracking_final(track_img, track_img_result, object_1, obj1_x, obj1_y, object_2,obj2_x, obj2_y, x1_updated, y1_updated, x2_updated, y2_updated)


figure(1);
% Unfiltered data set
subplot(1,3,1)
imagesc(track_img,[0 1600])
colorbar
title('Unfiltered data set')
xlabel('Display in x-direction');
ylabel('Display in y-direction');
axis image;

% Estimated position with RoI
subplot(1,3,2)
imagesc(track_img_result,[0 1600])
colorbar
if object_1 == 1
hold on;
    scatter(obj1_x,obj1_y,500,'k','x') 
    scatter(obj1_x,obj1_y,500,'k','o')
hold off;
end
if object_2 == 1
hold on;
    scatter(obj2_x,obj2_y,500,'k','x') 
    scatter(obj2_x,obj2_y,500,'k','o')
hold off;
end
title('Estimated position')
xlabel('Display in x-direction');
ylabel('Display in y-direction');
axis image;

% Updated position with RoI
subplot(1,3,3)
imagesc(track_img_result,[0 1600])
colorbar
if object_1 == 1
hold on;
    scatter(x1_updated, y1_updated,500,'k','x') 
    scatter(x1_updated, y1_updated,500,'k','o')
hold off;
end
if object_2 == 1
hold on;
    scatter(x2_updated, y2_updated,500,'k','x') 
    scatter(x2_updated, y2_updated,500,'k','o')
hold off;
end
title('Updated position (Kalman filter)')
xlabel('Display in x-direction');
ylabel('Display in y-direction');
axis image;

end
