function no_output = show_tracking_history(prev_track1_x, prev_track1_y, prev_track2_x, prev_track2_y, x1_updated, y1_updated, x2_updated, y2_updated, sim_length, x_size, y_size, plot_distance)

%% Basic track
figure(2);
subplot(2,2,1)
plot([0:0.02:(sim_length*0.02)-0.02],prev_track1_x, '-b')
hold on
plot([0:0.02:(sim_length*0.02)-0.02],x1_updated, '-r')
hold off
title('Estimated object1 x-value','FontSize',20)
xlabel('Time(s)');
ylabel('Display x-axis');
legend('True position','Estimated track')
%axis([0 sim_length 0 x_size])

subplot(2,2,2)
plot([0:0.02:(sim_length*0.02)-0.02],prev_track1_y)
hold on
plot([0:0.02:(sim_length*0.02)-0.02],y1_updated, '-r')
hold off
title('Estimated object 1 y-value','FontSize',20)
xlabel('Time(s)');
ylabel('Display y-axis');
legend('True position','Estimated track')
%axis([0 sim_length 0 y_size])

subplot(2,2,3)
plot([0:0.02:(sim_length*0.02)-0.02],prev_track2_x)
hold on
plot([0:0.02:(sim_length*0.02)-0.02],x2_updated, '-r')
hold off
title('Estimated object 2 x-value','FontSize',20)
xlabel('Time(s)');
ylabel('Display y-axis');
legend('True position','Estimated track')
%axis([0 sim_length 0 x_size])

subplot(2,2,4)
plot([0:0.02:(sim_length*0.02)-0.02],prev_track2_y)
hold on
plot([0:0.02:(sim_length*0.02)-0.02],y2_updated, '-r')
hold off
title('Estimated object 2 y-value','FontSize',20)
xlabel('Time(s)');
ylabel('Display y-axis');
legend('True position','Estimated track')
%axis([0 sim_length 0 y_size])

if plot_distance == 1

    % Distance between objects
    for i = 1:sim_length
        object_distance = sqrt( (prev_track1_x - prev_track2_x).^2 + (prev_track1_y - prev_track2_y).^2);
    end
    figure()
    plot([0:0.02:(sim_length*0.02)-0.02],object_distance)
    title('Estimated distance between both objects','FontSize',20)
    xlabel('Time(s)');
    ylabel('Distance');
end


end