function active_area = size_estimation(track_img, max_nx, max_ny)

active_area = zeros(1,4);
threshold_value = 100;
matrix_size = size(track_img);

SAN = ones(5,5);
if      max_nx == 1 & max_ny == 1 
    SAN(3:5,3:5) = track_img(max_ny:max_ny+2,max_nx:max_nx+2);
elseif  max_nx == matrix_size(2) & max_ny == 1 
    SAN(3:5,1:3) = track_img(max_ny:max_ny+2,max_nx-2:max_nx);
elseif  max_nx == 1 & max_ny == matrix_size(1) 
    SAN(1:3,3:5) = track_img(max_ny-2:max_ny,max_nx:max_nx+2);
elseif  max_nx == matrix_size(2) & max_ny == matrix_size(1) 
    SAN(1:3,1:3) = track_img(max_ny-2:max_ny,max_nx-2:max_nx);

    
% For one of the second outer corner nodes:
elseif      max_nx == 2 & max_ny == 2 
    SAN(2:5,2:5) = track_img(max_ny-1:max_ny+2,max_nx-1:max_nx+2);
elseif  max_nx == matrix_size(2)-1 & max_ny == 2 
    SAN(2:5,1:4) = track_img(max_ny-1:max_ny+2,max_nx-2:max_nx+1);
elseif  max_nx == 2 & max_ny == matrix_size(1)-1 
    SAN(1:4,2:5) = track_img(max_ny-2:max_ny+1,max_nx-1:max_nx+2);
elseif  max_nx == matrix_size(2)-1 & max_ny == matrix_size(1)-1 
    SAN(1:4,1:4) = track_img(max_ny-2:max_ny+1,max_nx-2:max_nx+1);


% Along outer frame/border of display:
elseif max_nx == 1 & max_ny == 2
    SAN(2:5,3:5) = track_img(max_ny-1:max_ny+2,max_nx:max_nx+2);
elseif max_nx == 1 & max_ny == matrix_size(1)-1
    SAN(1:4,3:5) = track_img(max_ny-2:max_ny+1,max_nx:max_nx+2);
elseif max_nx == 1
    SAN(1:5,3:5) = track_img(max_ny-2:max_ny+2,max_nx:max_nx+2);


elseif max_ny == 1 & max_nx == 2
    SAN(3:5,2:5) = track_img(max_ny:max_ny+2,max_nx-1:max_nx+2);
elseif max_ny == 1 & max_nx == matrix_size(2)-1
    SAN(3:5,1:4) = track_img(max_ny:max_ny+2,max_nx-2:max_nx+1);
elseif max_ny == 1
    SAN(3:5,1:5) = track_img(max_ny:max_ny+2,max_nx-2:max_nx+2);


elseif max_nx == matrix_size(2) & max_ny == 2
    SAN(2:5,1:3) = track_img(max_ny-1:max_ny+2,max_nx-2:max_nx);
elseif max_nx == matrix_size(2) & max_ny == matrix_size(1)-1
    SAN(1:4,1:3) = track_img(max_ny-2:max_ny+1,max_nx-2:max_nx);
elseif max_nx == matrix_size(2)
    SAN(1:5,1:3) = track_img(max_ny-2:max_ny+2,max_nx-2:max_nx);


elseif max_ny == matrix_size(1) & max_nx == 2
    SAN(1:3,2:5) = track_img(max_ny-2:max_ny,max_nx-1:max_nx+2);
elseif max_ny == matrix_size(1) & max_nx == matrix_size(2)-1
    SAN(1:3,1:4) = track_img(max_ny-2:max_ny,max_nx-2:max_nx+1);
elseif max_ny == matrix_size(1)
    SAN(1:3,1:5) = track_img(max_ny-2:max_ny,max_nx-2:max_nx+2);

% Along second outer frame/border of display:
elseif max_nx == 2
    SAN(1:5,2:5) = track_img(max_ny-2:max_ny+2,max_nx-1:max_nx+2);
elseif max_ny == 2
    SAN(2:5,1:5) = track_img(max_ny-1:max_ny+2,max_nx-2:max_nx+2);
elseif max_nx == matrix_size(2)-1
    SAN(1:5,1:4) = track_img(max_ny-2:max_ny+2,max_nx-2:max_nx+1);
elseif max_ny == matrix_size(1)-1
    SAN(1:4,1:5) = track_img(max_ny-2:max_ny+1,max_nx-2:max_nx+2);
else
    SAN = track_img(max_ny-2:max_ny+2,max_nx-2:max_nx+2);
end


%% Check and possibly expand from 3x3 PAN, in case of thumb
PAN = SAN(2:4,2:4);
%TAN = SAN;
%TAN(2:4,2:4) = 0;
thres_val = 0.2;

%if max(TAN(:)) > mean(PAN(:)) && max_value > 600

% Start with PAN
limits = [max_nx-1 max_nx+1;max_ny-1 max_ny+1]; % 1,1 = xmin, 1,2 = xmax, 2,1 = ymin, 2,2 =ymax
if limits(1,1) < 1
    limits(1,1) = 1;
end
if limits(2,1) < 1
    limits(2,1) = 1;
end
if limits(1,2) > matrix_size(2) - 1
    limits(1,2) = matrix_size(2);
end
if limits(2,2) > matrix_size(1) - 1
    limits(2,2) = matrix_size(1);
end

% Corner up/left, limits(1,1) and limits(2,1), xmin and ymin
if max_nx < 3
    size_i = 0;
elseif max_ny < 3
    size_i = 0;
elseif max_nx > max_ny
    size_i = max_ny - 2;
else 
    size_i = max_nx - 2;
end

for size_j = 1:size_i-1
    if track_img(max_ny-1-size_j,max_nx-1-size_j) > threshold_value && max_nx ~= 1 && max_ny ~= 1
        limits(1,1) = max_nx - size_j;
        limits(2,1) = max_ny - size_j;
    else
        break
    end
end

% Corner down/right, limits(1,2) and limits(2,2), xmax and ymax
if max_nx > (matrix_size(2)-2)
    size_i = 0;
elseif max_ny > (matrix_size(1)-2)
    size_i = 0;
elseif matrix_size(2)-max_nx > matrix_size(1) - max_ny
    size_i = matrix_size(1) - max_ny - 1;
else 
    size_i = matrix_size(2) - max_nx - 1;
end

for size_j = 1:size_i
    if track_img(max_ny+1+size_j,max_nx+1+size_j) > threshold_value && max_nx ~= matrix_size(2) && max_ny ~= matrix_size(1)
        limits(1,2) = max_nx + 1 + size_j; 
        limits(2,2) = max_ny + 1 + size_j;
    else
        break
    end
end

% Corner up/right, limits(1,2) and limits(2,1), xmax and ymin
if max_nx > (matrix_size(2)-2)
    size_i = 0;
elseif max_ny < 3
    size_i = 0;
elseif matrix_size(2) - max_nx > max_ny - 1
    size_i = max_ny - 2;
else 
    size_i = matrix_size(2) - max_nx - 1;
end

for size_j = 1:size_i
    if track_img(max_ny-1-size_j,max_nx+1+size_j) > threshold_value && max_nx ~= matrix_size(2) && max_ny ~= 1
        if limits(1,2) < max_nx+1+size_j
            limits(1,2) = max_nx+1+size_j;
        end
        if limits(2,1) > max_ny-1-size_j
            limits(2,1) = max_ny-1-size_j;
        end
    else
        break
    end
end

% Corner down/left, limits(1,1) and limits(2,2), xmin and ymax
if max_nx < 3
    size_i = 0;
elseif max_ny > (matrix_size(2)-2)
    size_i = 0;
elseif max_nx-1 > matrix_size(1) - max_ny
    size_i = matrix_size(1) - max_ny - 1;
else 
    size_i = max_nx-2;
end

for size_j = 1:size_i
    if track_img(max_ny+1+size_j,max_nx-1-size_j) > threshold_value && (max_nx ~= 1) && (max_ny ~= matrix_size(1))
        if limits(1,1) < max_nx-1-size_j
            limits(1,1) = max_nx-1-size_j;
        end
        if limits(2,2) > max_ny+1+size_j
            limits(2,2) = max_ny+1+size_j;
        end
    else
        break
    end
end

% x_min_1 straight left top
size_i = max_nx-1;
if max_nx ~= 1 && max_ny ~= 1
    for size_j = 1:size_i-1
        if track_img(max_ny-1,max_nx-1-size_j) > threshold_value
            if limits(1,1) > max_nx-1-size_j
                limits(1,1) = max_nx-1-size_j;
            end
        else
            break
        end
    end
end

% x_min left mid
size_i = max_nx-1;
if max_nx ~= 1
    for size_j = 1:size_i-1
        if track_img(max_ny,max_nx-1-size_j) > threshold_value
            if limits(1,1) > max_nx-1-size_j
                limits(1,1) = max_nx-1-size_j;
            end
        else
            break
        end
    end
end

% x_min_2 straight left bottom
size_i = max_nx-1;
if max_nx ~= 1 && max_ny ~= matrix_size(1)
    for size_j = 1:size_i-1
        if track_img(max_ny+1,max_nx-1-size_j) > threshold_value
            if limits(1,1) > max_nx-1-size_j
                limits(1,1) = max_nx-1-size_j;
            end
        else
            break
        end
    end
end

% x_max_1 straight right top
size_i = matrix_size(2) - max_nx;
if max_nx ~= matrix_size(2) && max_ny ~= 1
    for size_j = 1:size_i-1
        if track_img(max_ny-1,max_nx+1+size_j) > threshold_value
            if limits(1,2) < max_nx+1+size_j
                limits(1,2) = max_nx+1+size_j;
            end
        else
            break
        end
    end
end

% x_max right mid
size_i = matrix_size(2) - max_nx;
if max_nx ~= matrix_size(2)
    for size_j = 1:size_i-1
        if track_img(max_ny,max_nx+1+size_j) > threshold_value
            if limits(1,2) < max_nx+1+size_j
                limits(1,2) = max_nx+1+size_j;
            end
        else
            break
        end
    end
end

% x_max_2 straight right bottom
size_i = matrix_size(2) - max_nx;
if max_nx ~= matrix_size(2) && max_ny ~= matrix_size(1)
    for size_j = 1:size_i-1
        if track_img(max_ny+1,max_nx+1+size_j) > threshold_value
            if limits(1,2) < max_nx+1+size_j
                limits(1,2) = max_nx+1+size_j;
            end
        else
            break
        end
    end
end

% y_min_1 straight up left
size_i = max_ny-1;
if max_ny ~= 1 && max_nx ~= 1
    for size_j = 1:size_i-1
        if track_img(max_ny-1-size_j,max_nx-1) > threshold_value
            if limits(2,1) > max_ny-1-size_j
                limits(2,1) = max_ny-1-size_j;
            end
        else
            break
        end
    end
end

% y_min up mid
size_i = max_ny-1;
if max_ny ~= 1
    for size_j = 1:size_i-1
        if track_img(max_ny-1-size_j,max_nx) > threshold_value
            if limits(2,1) > max_ny-1-size_j
                limits(2,1) = max_ny-1-size_j;
            end
        else
            break
        end
    end
end

% y_min_2 straight up right
size_i = max_ny-1;
if max_ny ~= 1 && max_nx ~= matrix_size(2)
    for size_j = 1:size_i-1
        if track_img(max_ny-1-size_j,max_nx+1) > threshold_value
            if limits(2,1) > max_ny-1-size_j
                limits(2,1) = max_ny-1-size_j;
            end
        else
            break
        end
    end
end

% y_max_1 straight down left
size_i = matrix_size(1) - max_ny;
if max_ny ~= matrix_size(1) && max_nx ~= 1
    for size_j = 1:size_i-1
        if track_img(max_ny+1+size_j,max_nx-1) > threshold_value
            if limits(2,2) < max_ny+1+size_j
                limits(2,2) = max_ny+1+size_j;
            end
        else
            break
        end
    end
end

% y_max down mid
size_i = matrix_size(1) - max_ny;
if max_ny ~= matrix_size(1)
    for size_j = 1:size_i-1
        if track_img(max_ny+1+size_j,max_nx) > threshold_value
            if limits(2,2) < max_ny+1+size_j
                limits(2,2) = max_ny+1+size_j;
            end
        else
            break
        end
    end
end

% y_max_2 straight down right
size_i = matrix_size(1) - max_ny;
if max_ny ~= matrix_size(1) && max_nx ~= matrix_size(2)
    for size_j = 1:size_i-1
        if track_img(max_ny+1+size_j,max_nx+1) > threshold_value
            if limits(2,2) < max_ny+1+size_j
                limits(2,2) = max_ny+1+size_j;
            end
        else
            break
        end
    end
end

%% Set limits
x_min = limits(1,1);
x_max = limits(1,2);
y_min = limits(2,1);
y_max = limits(2,2);

active_area = [x_min, x_max, y_min, y_max];


end